Subject: Re: [RFD] gitweb: href() function to generate URLs for CGI

From: Jakub Narebski <[email-masked]>
Date: Tue, 22 Aug 2006 22:01:25 +0200

<opublikowany i wysłany>

Jakub Narebski wrote:

> Randal L. Schwartz wrote:
> 
>>>>>>> "Junio" == Junio C Hamano <[email-masked]> writes:
>> 
>> Junio>        my @result = (); 
>> Junio>         for (my $i = 0; $i < @mapping; $i += 2) {
>> Junio>                my ($name, $symbol) = ($mapping[$i], $mapping[$i+1]);
>> Junio>                if (defined $params{$name}) {
>> Junio>                        push @result, "$symbol=$params{$name}";
>> Junio>                }
>> Junio>        }
>> Junio>         return "$my_uri?" . esc_param(join(';', @result));
>> Junio> }
>> 
>> If you already depend on the LWP package, then the "URI" module
>> does precisely what you're reinventing.
>> 
>> my $uri = URI->new("http://host/base/path")
>> $uri->query_form(\%params);
>> my $result = $uri->as_string;
>> 
>> And I'd rely on Gisle Aas's experience about constructing these things
>> far more than the thread I've just witnessed here. :)
> 
> First, I'd rather not introduce new dependency to git (and I think Junio
> would agree). Second, more important, we do _parameters processing_,
> it means renaming parameters (e.g. 'file_name' in params is 'p' in CGI URI),
> in the future perhaps passing project via PATH_INFO not in query string,
> and sorting the CGI parameters.
> 
> So it wouldn't be as easy as writing 
>         $uri->query_form(\%params); 
>         return $uri->as_string;
> or as 
>         return "$my_uri?" . esc_param(join(";", "$_=$params{$_}") keys %params)'.

Third, read comment to esc_param:

        # quote unsafe chars, but keep the slash, even when it's not
        # correct, but quoted slashes look too horrible in bookmarks

I assume that URI module methods do not keep slash...
-- 
Jakub Narebski
Warsaw, Poland
ShadeHawk on #git